
// location of mathjax files.


var nagmathjax= ((window.location.protocol=="https:") ? "https" : "http" ) +
    "://cdnjs.cloudflare.com/ajax/libs/mathjax/2.7.0/";

// var nagmathjax=""../mathjax/";

var nagusecookies = 1 // set to anything else to stop use of cookies





var createCookie = function(name, value, days) {
    if(nagusecookies==1){
    var expires;
    if (days) {
        var date = new Date();
        date.setTime(date.getTime() + (days * 24 * 60 * 60 * 1000));
        expires = "; expires=" + date.toGMTString();
    }
    else {
        expires = "";
    }
    document.cookie = name + "=" + value + expires + "; path=/";
    }
}

function getCookie(c_name) {
    if (document.cookie.length > 0) {
        c_start = document.cookie.indexOf(c_name + "=");
        if (c_start != -1) {
            c_start = c_start + c_name.length + 1;
            c_end = document.cookie.indexOf(";", c_start);
            if (c_end == -1) {
                c_end = document.cookie.length;
            }
            return unescape(document.cookie.substring(c_start, c_end));
        }
    }
    return "";
}



function hasSVG () {
return !! document.createElementNS &&
       !! document.createElementNS (
             'http://www.w3.org/2000/svg',
             "svg")
      .createSVGRect;
}




function getmathnode() {
    var mmlnodea = document.getElementsByTagName("math");
    var mmlnode = [];
    for( var i = 0; i < mmlnodea.length; i++ ) {
        mmlnode[mmlnode.length] = mmlnodea[i];
    }
    return mmlnode;
}



function doMathIE9() {
    var mmlnode = getmathnode();
    for (var i=0; i<mmlnode.length; i++) {
        var parent = mmlnode[i].parentNode;
        if(parent!=null){
            var str=parent.innerHTML;
	    if(str!=undefined) {
            str = str.replace(/xmlns=.http:\/\/www.w3.org\/1998\/Math\/MathML./ig,'');
            str = str.replace(/<\?XML:NAMESPACE[^<>]*>/ig,'');
            str = str.replace(/<\/(none|mprescripts|mspace)[^<>]*>/ig,'');
            str = str.replace(/<(none|mprescripts|mspace)([^<>]*)>/ig,'<$1$2></$1>');
            str = str.replace(/<(mtd)([^<>]*)>(?=\s*<mtd)/ig,'<$1$2></$1>');
            str = str.replace(/(<\/mtd>)+<\/mtr>/ig,'</mtd></mtr>');
            parent.innerHTML = (str);
	    } 
        }
    }

    doMathJax();
}

function SVGpng() {
    var svgnodea = document.getElementsByTagName("svg");
    var svgnode = [];
    for( var i = 0; i < svgnodea.length; i++ ) {
        svgnode[svgnode.length] = svgnodea[i];
    }
      for (var i=0; i<svgnode.length; i++) { 
        var newnode = 
            document.createElement("img");
          var d1=svgnode[i].parentNode;
          var d2=d1.parentNode;
          newnode.setAttribute("src","../figures/" + d2.getAttribute("id") + ".png");
          d2.replaceChild(newnode,d1);
    }
}



function doMathJax() {
    if(!(hasSVG())) {
	SVGpng();
    }
   var scr=document.createElement("script");
   scr.setAttribute("src",nagmathjax + "MathJax.js?config=TeX-AMS-MML_SVG");
   document.getElementsByTagName("head")[0].appendChild(scr);
   
}




// TOC handler
function showLevel(id){
    var thisLevel = document.getElementById(id);
    var thisplus = document.getElementById(id +'plus');
    var thisminus = document.getElementById(id + 'minus');
    if(getComputedStyle(thisLevel).getPropertyValue("display") != "block"){
	thisLevel.style.display = "block";
	thisplus.style.display = "none";
	thisminus.style.display = "inline";
	thisLevel.parentNode.scrollIntoView();
    } else {
	thisLevel.style.display = "none";
	thisminus.style.display = "none";
	thisplus.style.display = "inline";
    }
}

function ksearch (t,e) {
    if (e.keyCode == 13) {
	document.location='../indexes/kwic.html?q='+t.value.replace(/[ ,]+/g, '+');
	return false;
    }
}




function showName (nd,n) {
    createCookie("nagname",n,100);
    var nagnameslist=document.getElementsByClassName("c-name");
    for (var i=0, max=nagnameslist.length; i < max; i++) {
	if(n=="s") {
            nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-s");
	} else if(n=="l" || n=="f"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-l");
	}
    }
    var nagnamesul=document.getElementsByClassName("nameslist");
     for (var i=0, max=nagnamesul.length; i < max; i++) {
	 sortUlList(nagnamesul[i]);
     }
    nagnameslist=document.getElementsByClassName("r-name");
    for (var i=0, max=nagnameslist.length; i < max; i++) {
	if(n=="s") {
            nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-s");
	} else if(n=="l"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-l");
	} else if(n=="f"){
	    nagnameslist[i].innerHTML=nagnameslist[i].getAttribute("data-f");
	}
    }
    var nagnamesul=document.getElementsByClassName("tableconts");
     for (var i=0, max=nagnamesul.length; i < max; i++) {
	 sortUlList(nagnamesul[i]);
     }
}

// not necessarily a ul sorting li (eg works with tbody sorting row)
function sortUlList(ul){
    var newul = ul.cloneNode(false);
    var lilist = [];
    for(var i = ul.childNodes.length; i--;){
        if(ul.childNodes[i].nodeName !== '')
            lilist.push(ul.childNodes[i]);
    }
    // Sort 
    lilist.sort(function(a, b){
      if (a.textContent < b.textContent)
        return -1;
      if (a.textContent > b.textContent)
        return 1;
      return 0;
    });
    for(var i = 0; i < lilist.length; i++)
        newul.appendChild(lilist[i]);
    ul.parentNode.replaceChild(newul, ul);
}

// spec picker test (to be moved to nagmathml.js)

function showSpec (nd,l) {
    var nagspeclist=document.querySelectorAll("div." + l);
    var cppforc = false;
    // ad only has C++
    if (l=="flcspec" && nagspeclist.length==0 && nd.checked) {
        cppforc=true;
	nagspeclist=document.querySelectorAll("div.flcppspec");
    }
    var langs="";
    inps=nd.parentNode.parentNode.getElementsByTagName("input");
    for (var i=0, max=inps.length; i < max; i++) {
	if(inps[i].checked) langs=langs+(langs==""?"":",")+inps[i].getAttribute("id").substring(4);
    }
    createCookie("speclang",langs,100);
    for (var i=0, max=nagspeclist.length; i < max; i++) {
	if(nd.checked || (nd.id == 'showcpp' && cppforc)) {
            nagspeclist[i].style.display="block";
	} else {
            nagspeclist[i].style.display="none";
	}
    }
}

function getQueryVariable(variable)
{
       var query = window.location.search.substring(1);
       var vars = query.split("&");
       for (var i=0;i<vars.length;i++) {
               var pair = vars[i].split("=");
               if(pair[0] == variable){return pair[1];}
       }
       return(false);
}
function setSpecLanguage () {
    var lstr=getQueryVariable("spec");
    if(!lstr) {
	lstr=getCookie("speclang");
    }
    if(lstr) {
	var inp;
	inp=document.getElementById('showf90');
	if(inp != null) inp.checked=false;
	inp=document.getElementById('showc');
	if(inp != null) inp.checked=false;
	inp=document.getElementById('showcpp');
	if(inp != null) inp.checked=false;
	var llist=lstr.split(",");
	for (var i=0; i<llist.length; i++) {
	    inp=document.getElementById('show'+llist[i]);
	    if(inp!=null) inp.checked=true;
	}
	// initilialize c after cpp for AD (which has no C and usets CPP)
	inp=document.getElementById('showf90');
	if(inp != null) showSpec(inp,'fspec');
	inp=document.getElementById('showcpp');
	if(inp != null) showSpec(inp,'flcppspec');
	inp=document.getElementById('showc');
	if(inp != null) showSpec(inp,'flcspec');
    }
}




// end of spec picker test

function setNagNames () {
    var ncq=getQueryVariable("names");
    var nc=false;
    if(ncq=="long") {
	nc="l";
    } else if(ncq=="short") {
	nc="s";
    } else if(ncq=="full") {
	nc="f";
    } else {
	nc=getCookie("nagname");
    }
    if (nc) {
	var inel=document.getElementById("name" + nc);
	if( inel != null) {
	    inel.checked=true;
	    showName(inel,nc);
	}
    }
}

if ( navigator.userAgent.match(/Gecko\//) && (! navigator.userAgent.match(/Firefox[ /][1-3][^0-9]/))) {
    // native MathML and SVG in current firefox
    window.addEventListener('load', setNagNames, false);
    window.addEventListener('load', setSpecLanguage, false);
} else if ( window.attachEvent && navigator.userAgent.match(/MSIE [6-9][^0-9]/)) {
    window.attachEvent("onload", doMathIE9);
    window.attachEvent("onload", setNagNames);
    window.attachEvent("onload", setSpecLanguage);
} else if ( window.addEventListener) {
    window.addEventListener('load', doMathJax, false);
    window.addEventListener('load', setNagNames, false);
    window.addEventListener('load', setSpecLanguage, false);
} 
